aubio 0.4.9

Loading...
Searching...
No Matches
onset.h
Go to the documentation of this file.
1/*
2 Copyright (C) 2006-2013 Paul Brossier <piem@aubio.org>
3
4 This file is part of aubio.
5
6 aubio is free software: you can redistribute it and/or modify
7 it under the terms of the GNU General Public License as published by
8 the Free Software Foundation, either version 3 of the License, or
9 (at your option) any later version.
10
11 aubio is distributed in the hope that it will be useful,
12 but WITHOUT ANY WARRANTY; without even the implied warranty of
13 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
14 GNU General Public License for more details.
15
16 You should have received a copy of the GNU General Public License
17 along with aubio. If not, see <http://www.gnu.org/licenses/>.
18
19*/
20
21/** \file
22
23 Onset detection object
24
25 The following routines compute the onset detection function and detect peaks
26 in these functions. When onsets are found above a given silence threshold,
27 and after a minimum inter-onset interval, the output vector returned by
28 aubio_onset_do() is filled with `1`. Otherwise, the output vector remains
29 `0`.
30
31 The peak-picking threshold, the silence threshold, and the minimum
32 inter-onset interval can be adjusted during the execution of the
33 aubio_onset_do routine using the corresponding functions.
34
35 \example onset/test-onset.c
36 \example examples/aubioonset.c
37 \example examples/aubionotes.c
38
39*/
40
41
42#ifndef AUBIO_ONSET_H
43#define AUBIO_ONSET_H
44
45#ifdef __cplusplus
46 extern "C" {
47#endif
48
49/** onset detection object */
50 typedef struct _aubio_onset_t aubio_onset_t;
51
52/** create onset detection object
53
54 \param method onset detection type as specified in specdesc.h
55 \param buf_size buffer size for phase vocoder
56 \param hop_size hop size for phase vocoder
57 \param samplerate sampling rate of the input signal
58
59 \return newly created ::aubio_onset_t
60
61*/
62 aubio_onset_t * new_aubio_onset (const char_t * method,
63 uint_t buf_size, uint_t hop_size, uint_t samplerate);
64
65/** execute onset detection
66
67 \param o onset detection object as returned by new_aubio_onset()
68 \param input new audio vector of length hop_size
69 \param onset output vector of length 1, containing 0 if no onset was found,
70 and a value equal or greater than 1 otherwise
71
72 When no onset was detected, the first element of the output vector `onset`
73 is set to 0.
74
75 When an onset is found, the first element of the output vector `onset` is set
76 to `offset = 1 + a` where `a` is a number in the range`[0, 1]`.
77
78 The final onset detection time, in samples, can be obtained with
79 aubio_onset_get_last(). It can also be derived from `offset` as
80 follows:
81
82 \code
83 t = total_frames + offset * hop_size - delay
84 \endcode
85
86 where `total_frames` is the total number of frames processed so far, and
87 `delay` is the current delay of the onset object, as returned by
88 aubio_onset_get_delay().
89
90*/
91 void aubio_onset_do (aubio_onset_t *o, const fvec_t * input, fvec_t * onset);
92
93/** get the time of the latest onset detected, in samples
94
95 \param o onset detection object as returned by new_aubio_onset()
96
97 \return onset detection timestamps (in samples)
98
99*/
100 uint_t aubio_onset_get_last (const aubio_onset_t *o);
101
102/** get the time of the latest onset detected, in seconds
103
104 \param o onset detection object as returned by new_aubio_onset()
105
106 \return onset detection timestamps (in seconds)
107
108*/
109 smpl_t aubio_onset_get_last_s (const aubio_onset_t *o);
110
111/** get the time of the latest onset detected, in milliseconds
112
113 \param o onset detection object as returned by new_aubio_onset()
114
115 \return onset detection timestamps (in milliseconds)
116
117*/
118 smpl_t aubio_onset_get_last_ms (const aubio_onset_t *o);
119
120/** set onset detection adaptive whitening
121
122 \param o onset detection object as returned by new_aubio_onset()
123 \param enable 1 to enable, 0 to disable
124
125 \return 0 if successful, 1 otherwise
126
127*/
128 uint_t aubio_onset_set_awhitening(aubio_onset_t * o, uint_t enable);
129
130/** get onset detection adaptive whitening
131
132 \param o onset detection object as returned by new_aubio_onset()
133
134 \return 1 if enabled, 0 otherwise
135
136*/
137 smpl_t aubio_onset_get_awhitening(aubio_onset_t * o);
138
139/** set or disable log compression
140
141 \param o onset detection object as returned by new_aubio_onset()
142 \param lambda logarithmic compression factor, 0 to disable
143
144 \return 0 if successful, 1 otherwise
145
146 */
147 uint_t aubio_onset_set_compression(aubio_onset_t *o, smpl_t lambda);
148
149/** get onset detection log compression
150
151 \param o onset detection object as returned by new_aubio_onset()
152
153 \returns 0 if disabled, compression factor otherwise
154
155 */
156 smpl_t aubio_onset_get_compression(aubio_onset_t *o);
157
158/** set onset detection silence threshold
159
160 \param o onset detection object as returned by new_aubio_onset()
161 \param silence new silence detection threshold
162
163*/
164 uint_t aubio_onset_set_silence(aubio_onset_t * o, smpl_t silence);
165
166/** get onset detection silence threshold
167
168 \param o onset detection object as returned by new_aubio_onset()
169
170 \return current silence threshold
171
172*/
173 smpl_t aubio_onset_get_silence(const aubio_onset_t * o);
174
175/** get onset detection function
176
177 \param o onset detection object as returned by new_aubio_onset()
178 \return the current value of the descriptor
179
180*/
181 smpl_t aubio_onset_get_descriptor (const aubio_onset_t *o);
182
183/** get thresholded onset detection function
184
185 \param o onset detection object as returned by new_aubio_onset()
186 \return the value of the thresholded descriptor
187
188*/
189 smpl_t aubio_onset_get_thresholded_descriptor (const aubio_onset_t *o);
190
191/** set onset detection peak picking threshold
192
193 \param o onset detection object as returned by new_aubio_onset()
194 \param threshold new peak-picking threshold
195
196*/
197 uint_t aubio_onset_set_threshold(aubio_onset_t * o, smpl_t threshold);
198
199/** set minimum inter onset interval in samples
200
201 \param o onset detection object as returned by new_aubio_onset()
202 \param minioi minimum interval between two consecutive onsets (in
203 samples)
204
205*/
206 uint_t aubio_onset_set_minioi(aubio_onset_t * o, uint_t minioi);
207
208/** set minimum inter onset interval in seconds
209
210 \param o onset detection object as returned by new_aubio_onset()
211 \param minioi minimum interval between two consecutive onsets (in
212 seconds)
213
214*/
215 uint_t aubio_onset_set_minioi_s(aubio_onset_t * o, smpl_t minioi);
216
217/** set minimum inter onset interval in milliseconds
218
219 \param o onset detection object as returned by new_aubio_onset()
220 \param minioi minimum interval between two consecutive onsets (in
221 milliseconds)
222
223*/
224 uint_t aubio_onset_set_minioi_ms(aubio_onset_t * o, smpl_t minioi);
225
226/** set delay in samples
227
228 \param o onset detection object as returned by new_aubio_onset()
229 \param delay constant system delay to take back from detection time
230 (in samples)
231
232*/
233 uint_t aubio_onset_set_delay(aubio_onset_t * o, uint_t delay);
234
235/** set delay in seconds
236
237 \param o onset detection object as returned by new_aubio_onset()
238 \param delay constant system delay to take back from detection time
239 (in seconds)
240
241*/
242 uint_t aubio_onset_set_delay_s(aubio_onset_t * o, smpl_t delay);
243
244/** set delay in milliseconds
245
246 \param o onset detection object as returned by new_aubio_onset()
247 \param delay constant system delay to take back from detection time
248 (in milliseconds)
249
250*/
251 uint_t aubio_onset_set_delay_ms(aubio_onset_t * o, smpl_t delay);
252
253/** get minimum inter onset interval in samples
254
255 \param o onset detection object as returned by new_aubio_onset()
256 \return minimum interval between two consecutive onsets (in
257 samples)
258
259*/
260 uint_t aubio_onset_get_minioi(const aubio_onset_t * o);
261
262/** get minimum inter onset interval in seconds
263
264 \param o onset detection object as returned by new_aubio_onset()
265 \return minimum interval between two consecutive onsets (in
266 seconds)
267
268*/
269 smpl_t aubio_onset_get_minioi_s(const aubio_onset_t * o);
270
271/** get minimum inter onset interval in milliseconds
272
273 \param o onset detection object as returned by new_aubio_onset()
274 \return minimum interval between two consecutive onsets (in
275 milliseconds)
276
277*/
278 smpl_t aubio_onset_get_minioi_ms(const aubio_onset_t * o);
279
280/** get delay in samples
281
282 \param o onset detection object as returned by new_aubio_onset()
283 \return constant system delay to take back from detection time
284 (in samples)
285
286*/
287 uint_t aubio_onset_get_delay(const aubio_onset_t * o);
288
289/** get delay in seconds
290
291 \param o onset detection object as returned by new_aubio_onset()
292 \return constant system delay to take back from detection time
293 (in seconds)
294
295*/
296 smpl_t aubio_onset_get_delay_s(const aubio_onset_t * o);
297
298/** get delay in milliseconds
299
300 \param o onset detection object as returned by new_aubio_onset()
301 \return constant system delay to take back from detection time
302 (in milliseconds)
303
304*/
305 smpl_t aubio_onset_get_delay_ms(const aubio_onset_t * o);
306
307/** get onset peak picking threshold
308
309 \param o onset detection object as returned by new_aubio_onset()
310 \return current onset detection threshold
311
312*/
313 smpl_t aubio_onset_get_threshold(const aubio_onset_t * o);
314
315/** set default parameters
316
317 \param o onset detection object as returned by new_aubio_onset()
318 \param onset_mode detection mode to adjust
319
320 This function is called at the end of new_aubio_onset().
321
322 */
323 uint_t aubio_onset_set_default_parameters (aubio_onset_t * o, const char_t * onset_mode);
324
325/** reset onset detection
326
327 \param o onset detection object as returned by new_aubio_onset()
328
329 Reset current time and last onset to 0.
330
331 This function is called at the end of new_aubio_onset().
332
333 */
334 void aubio_onset_reset(aubio_onset_t * o);
335
336/** delete onset detection object
337
338 \param o onset detection object to delete
339
340*/
341 void del_aubio_onset(aubio_onset_t * o);
342
343#ifdef __cplusplus
344}
345#endif
346
347#endif /* AUBIO_ONSET_H */
aubio_onset_get_thresholded_descriptor
smpl_t aubio_onset_get_thresholded_descriptor(const aubio_onset_t *o)
get thresholded onset detection function
aubio_onset_set_default_parameters
uint_t aubio_onset_set_default_parameters(aubio_onset_t *o, const char_t *onset_mode)
set default parameters
aubio_onset_set_threshold
uint_t aubio_onset_set_threshold(aubio_onset_t *o, smpl_t threshold)
set onset detection peak picking threshold
aubio_onset_do
void aubio_onset_do(aubio_onset_t *o, const fvec_t *input, fvec_t *onset)
execute onset detection
aubio_onset_set_minioi_ms
uint_t aubio_onset_set_minioi_ms(aubio_onset_t *o, smpl_t minioi)
set minimum inter onset interval in milliseconds
aubio_onset_get_threshold
smpl_t aubio_onset_get_threshold(const aubio_onset_t *o)
get onset peak picking threshold
aubio_onset_get_last
uint_t aubio_onset_get_last(const aubio_onset_t *o)
get the time of the latest onset detected, in samples
aubio_onset_set_compression
uint_t aubio_onset_set_compression(aubio_onset_t *o, smpl_t lambda)
set or disable log compression
aubio_onset_get_delay_ms
smpl_t aubio_onset_get_delay_ms(const aubio_onset_t *o)
get delay in milliseconds
del_aubio_onset
void del_aubio_onset(aubio_onset_t *o)
delete onset detection object
aubio_onset_get_awhitening
smpl_t aubio_onset_get_awhitening(aubio_onset_t *o)
get onset detection adaptive whitening
aubio_onset_get_delay_s
smpl_t aubio_onset_get_delay_s(const aubio_onset_t *o)
get delay in seconds
aubio_onset_get_minioi
uint_t aubio_onset_get_minioi(const aubio_onset_t *o)
get minimum inter onset interval in samples
aubio_onset_get_descriptor
smpl_t aubio_onset_get_descriptor(const aubio_onset_t *o)
get onset detection function
aubio_onset_get_last_s
smpl_t aubio_onset_get_last_s(const aubio_onset_t *o)
get the time of the latest onset detected, in seconds
aubio_onset_get_delay
uint_t aubio_onset_get_delay(const aubio_onset_t *o)
get delay in samples
aubio_onset_reset
void aubio_onset_reset(aubio_onset_t *o)
reset onset detection
aubio_onset_t
struct _aubio_onset_t aubio_onset_t
onset detection object
Definition onset.h:50
aubio_onset_set_delay_ms
uint_t aubio_onset_set_delay_ms(aubio_onset_t *o, smpl_t delay)
set delay in milliseconds
aubio_onset_set_silence
uint_t aubio_onset_set_silence(aubio_onset_t *o, smpl_t silence)
set onset detection silence threshold
aubio_onset_get_minioi_ms
smpl_t aubio_onset_get_minioi_ms(const aubio_onset_t *o)
get minimum inter onset interval in milliseconds
aubio_onset_set_minioi
uint_t aubio_onset_set_minioi(aubio_onset_t *o, uint_t minioi)
set minimum inter onset interval in samples
aubio_onset_get_compression
smpl_t aubio_onset_get_compression(aubio_onset_t *o)
get onset detection log compression
aubio_onset_set_delay_s
uint_t aubio_onset_set_delay_s(aubio_onset_t *o, smpl_t delay)
set delay in seconds
aubio_onset_set_delay
uint_t aubio_onset_set_delay(aubio_onset_t *o, uint_t delay)
set delay in samples
aubio_onset_set_minioi_s
uint_t aubio_onset_set_minioi_s(aubio_onset_t *o, smpl_t minioi)
set minimum inter onset interval in seconds
aubio_onset_get_silence
smpl_t aubio_onset_get_silence(const aubio_onset_t *o)
get onset detection silence threshold
aubio_onset_get_minioi_s
smpl_t aubio_onset_get_minioi_s(const aubio_onset_t *o)
get minimum inter onset interval in seconds
aubio_onset_set_awhitening
uint_t aubio_onset_set_awhitening(aubio_onset_t *o, uint_t enable)
set onset detection adaptive whitening
aubio_onset_get_last_ms
smpl_t aubio_onset_get_last_ms(const aubio_onset_t *o)
get the time of the latest onset detected, in milliseconds
new_aubio_onset
aubio_onset_t * new_aubio_onset(const char_t *method, uint_t buf_size, uint_t hop_size, uint_t samplerate)
create onset detection object
fvec_t
Buffer for real data.
Definition fvec.h:67
uint_t
unsigned int uint_t
unsigned integer
Definition types.h:60
char_t
char char_t
character
Definition types.h:64
smpl_t
float smpl_t
short sample format (32 or 64 bits)
Definition types.h:41